package algorithms;

import java.io.Serializable;
import java.util.List;
import objects.DistanceMatrix;
import objects.Template;

public abstract class Decision implements Serializable {

    private List gallery;
    private DistanceTemplates distanceTemplates;
    private DistanceMatrix distanceMatrix;

    public Decision() {
    }

    public List getGallery() {
        return gallery;
    }

    public void setGallery(List gallery) {
        this.gallery = gallery;
    }

    public DistanceTemplates getDistanceTemplates() {
        return distanceTemplates;
    }

    public void setDistanceTemplates(DistanceTemplates distanceTemplates) {
        this.distanceTemplates = distanceTemplates;
    }

    public void setDistanceMatrix(DistanceMatrix distanceMatrix) {
        this.distanceMatrix = distanceMatrix;
    }

    public double getDistance(Template template1, Template template2) {
        return distanceMatrix == null ? distanceTemplates.getDistance(template1, template2) : distanceMatrix.getDistance(template1, template2);
    }

    public abstract void importGallery(List<Template> templatesGallery);

    public abstract String decide(Template template);
}
