package objects;

import java.io.Serializable;

public class Classifiable implements Serializable {

    private final String identifier;

    public Classifiable(String identifier) {
        this.identifier = identifier;
    }

    public String getIdentifier() {
        return identifier;
    }

    public String getSubject() {
        return identifier.split("_")[0];
    }

    public String getSequence() {
        return identifier.split("_")[1];
    }
    
    public boolean hasSameSubjectAs(Classifiable object){
        return getSubject().equals(object.getSubject());
    }
    
    public boolean hasSameSequenceAs(Classifiable object){
        return getSequence().equals(object.getSequence());
    }
    
    public boolean hasSameIdentifierAs(Classifiable object){
        return getIdentifier().equals(object.getIdentifier());
    }
}
